import Nimble

print("Start execution...")

// Setup custom assertion handler
Nimble.NimbleAssertionHandler = MyAssertionHandler()


// My type and custom predicate
struct MyType {
    var name: String
}

func myPredicate(name: String) -> Predicate<MyType> {
    return .simple { expression in
        guard let value = try expression.evaluate() else {
            return .fail
        }
        
        return .init(bool: value.name == name)
    }
}

// Test
let info = MyType(name: "Hello World")
expect(info).to(myPredicate(name: "Hello"))
expect(info).to(myPredicate(name: "Hello World"))
